gtkmm: Gtk::ScrolledWindow Class Reference

gtkmm 4.23.0

Public Member Functions | Static Public Member Functions | Related Symbols | List of all members
Gtk::ScrolledWindow Class Reference
Widgets | Container Widgets

A container that makes its child scrollable. More...

`#include <gtkmm/scrolledwindow.h>`

Inheritance diagram for Gtk::ScrolledWindow:
[legend]

## Public Member Functions
| ScrolledWindow (ScrolledWindow && src) noexcept
ScrolledWindow & | operator= (ScrolledWindow && src) noexcept
| ScrolledWindow (const ScrolledWindow &)=delete
ScrolledWindow & | operator= (const ScrolledWindow &)=delete
| ~ScrolledWindow () noexcept override
GtkScrolledWindow * | gobj ()
| Provides access to the underlying C GObject.
const GtkScrolledWindow * | gobj () const
| Provides access to the underlying C GObject.
| ScrolledWindow ()
void | set_hadjustment (const Glib::RefPtr< Adjustment > & hadjustment)
| Sets the Gtk::Adjustment for the horizontal scrollbar.
void | set_vadjustment (const Glib::RefPtr< Adjustment > & vadjustment)
| Sets the Gtk::Adjustment for the vertical scrollbar.
Glib::RefPtr< Adjustment > | get_hadjustment ()
| Returns the horizontal scrollbar’s adjustment.
Glib::RefPtr< const Adjustment > | get_hadjustment () const
| Returns the horizontal scrollbar’s adjustment.
Glib::RefPtr< Adjustment > | get_vadjustment ()
| Returns the vertical scrollbar’s adjustment.
Glib::RefPtr< const Adjustment > | get_vadjustment () const
| Returns the vertical scrollbar’s adjustment.
void | set_policy (PolicyType hscrollbar_policy, PolicyType vscrollbar_policy)
| Sets the scrollbar policy for the horizontal and vertical scrollbars.
void | get_policy (PolicyType & hscrollbar_policy, PolicyType & vscrollbar_policy) const
| Retrieves the current policy values for the horizontal and vertical scrollbars.
void | set_placement (CornerType window_placement)
| Sets the placement of the contents with respect to the scrollbars for the scrolled window.
void | unset_placement ()
| Unsets the placement of the contents with respect to the scrollbars.
CornerType | get_placement () const
| Gets the placement of the contents with respect to the scrollbars.
void | set_has_frame (bool has_frame=true)
| Changes the frame drawn around the contents of scrolled_window.
bool | get_has_frame () const
| Gets whether the scrolled window draws a frame.
Scrollbar * | get_vscrollbar ()
| Returns the vertical scrollbar of scrolled_window.
const Scrollbar * | get_vscrollbar () const
| Returns the vertical scrollbar of scrolled_window.
Scrollbar * | get_hscrollbar ()
| Returns the horizontal scrollbar of scrolled_window.
const Scrollbar * | get_hscrollbar () const
| Returns the horizontal scrollbar of scrolled_window.
int | get_min_content_width () const
| Gets the minimum content width of scrolled_window.
void | set_min_content_width (int width)
| Sets the minimum width that scrolled_window should keep visible.
int | get_min_content_height () const
| Gets the minimal content height of scrolled_window.
void | set_min_content_height (int height)
| Sets the minimum height that scrolled_window should keep visible.
void | set_kinetic_scrolling (bool kinetic_scrolling=true)
| Turns kinetic scrolling on or off.
bool | get_kinetic_scrolling () const
| Returns the specified kinetic scrolling behavior.
void | set_overlay_scrolling (bool overlay_scrolling=true)
| Enables or disables overlay scrolling for this scrolled window.
bool | get_overlay_scrolling () const
| Returns whether overlay scrolling is enabled for this scrolled window.
void | set_max_content_width (int width)
| Sets the maximum width that scrolled_window should keep visible.
int | get_max_content_width () const
| Returns the maximum content width set.
void | set_max_content_height (int height)
| Sets the maximum height that scrolled_window should keep visible.
int | get_max_content_height () const
| Returns the maximum content height set.
void | set_propagate_natural_width (bool propagate=true)
| Sets whether the natural width of the child should be calculated and propagated through the scrolled window’s requested natural width.
bool | get_propagate_natural_width () const
| Reports whether the natural width of the child will be calculated and propagated through the scrolled window’s requested natural width.
void | set_propagate_natural_height (bool propagate=true)
| Sets whether the natural height of the child should be calculated and propagated through the scrolled window’s requested natural height.
bool | get_propagate_natural_height () const
| Reports whether the natural height of the child will be calculated and propagated through the scrolled window’s requested natural height.
void | set_child (Widget & child)
| Sets the child widget of scrolled_window.
void | unset_child ()
Widget * | get_child ()
| Gets the child widget of scrolled_window.
const Widget * | get_child () const
| Gets the child widget of scrolled_window.
Glib::SignalProxy< void(Gtk::PositionType)> | signal_edge_overshot ()
Glib::SignalProxy< void(Gtk::PositionType)> | signal_edge_reached ()
Glib::PropertyProxy< Glib::RefPtr< Adjustment > > | property_hadjustment ()
| The Gtk::Adjustment for the horizontal position.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Adjustment > > | property_hadjustment () const
| The Gtk::Adjustment for the horizontal position.
Glib::PropertyProxy< Glib::RefPtr< Adjustment > > | property_vadjustment ()
| The Gtk::Adjustment for the vertical position.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Adjustment > > | property_vadjustment () const
| The Gtk::Adjustment for the vertical position.
Glib::PropertyProxy< PolicyType > | property_hscrollbar_policy ()
| When the horizontal scrollbar is displayed.
Glib::PropertyProxy_ReadOnly< PolicyType > | property_hscrollbar_policy () const
| When the horizontal scrollbar is displayed.
Glib::PropertyProxy< PolicyType > | property_vscrollbar_policy ()
| When the vertical scrollbar is displayed.
Glib::PropertyProxy_ReadOnly< PolicyType > | property_vscrollbar_policy () const
| When the vertical scrollbar is displayed.
Glib::PropertyProxy< CornerType > | property_window_placement ()
| Where the contents are located with respect to the scrollbars.
Glib::PropertyProxy_ReadOnly< CornerType > | property_window_placement () const
| Where the contents are located with respect to the scrollbars.
Glib::PropertyProxy< bool > | property_has_frame ()
| Whether to draw a frame around the contents.
Glib::PropertyProxy_ReadOnly< bool > | property_has_frame () const
| Whether to draw a frame around the contents.
Glib::PropertyProxy< int > | property_min_content_width ()
| The minimum content width of scrolled_window.
Glib::PropertyProxy_ReadOnly< int > | property_min_content_width () const
| The minimum content width of scrolled_window.
Glib::PropertyProxy< int > | property_min_content_height ()
| The minimum content height of scrolled_window.
Glib::PropertyProxy_ReadOnly< int > | property_min_content_height () const
| The minimum content height of scrolled_window.
Glib::PropertyProxy< bool > | property_kinetic_scrolling ()
| Whether kinetic scrolling is enabled or not.
Glib::PropertyProxy_ReadOnly< bool > | property_kinetic_scrolling () const
| Whether kinetic scrolling is enabled or not.
Glib::PropertyProxy< bool > | property_overlay_scrolling ()
| Whether overlay scrolling is enabled or not.
Glib::PropertyProxy_ReadOnly< bool > | property_overlay_scrolling () const
| Whether overlay scrolling is enabled or not.
Glib::PropertyProxy< int > | property_max_content_width ()
| The maximum content width of scrolled_window.
Glib::PropertyProxy_ReadOnly< int > | property_max_content_width () const
| The maximum content width of scrolled_window.
Glib::PropertyProxy< int > | property_max_content_height ()
| The maximum content height of scrolled_window.
Glib::PropertyProxy_ReadOnly< int > | property_max_content_height () const
| The maximum content height of scrolled_window.
Glib::PropertyProxy< bool > | property_propagate_natural_width ()
| Whether the natural width of the child should be calculated and propagated through the scrolled window’s requested natural width.
Glib::PropertyProxy_ReadOnly< bool > | property_propagate_natural_width () const
| Whether the natural width of the child should be calculated and propagated through the scrolled window’s requested natural width.
Glib::PropertyProxy< bool > | property_propagate_natural_height ()
| Whether the natural height of the child should be calculated and propagated through the scrolled window’s requested natural height.
Glib::PropertyProxy_ReadOnly< bool > | property_propagate_natural_height () const
| Whether the natural height of the child should be calculated and propagated through the scrolled window’s requested natural height.
Glib::PropertyProxy< Widget * > | property_child ()
| The child widget.
Glib::PropertyProxy_ReadOnly< Widget * > | property_child () const
| The child widget.
Public Member Functions inherited from Gtk::Widget
| Widget (Widget && src) noexcept
Widget & | operator= (Widget && src) noexcept
| Widget (const Widget &)=delete
Widget & | operator= (const Widget &)=delete
| ~Widget () noexcept override
| Destroys the widget.
GtkWidget * | gobj ()
| Provides access to the underlying C GObject.
const GtkWidget * | gobj () const
| Provides access to the underlying C GObject.
Glib::RefPtr< ConstraintTarget > | make_refptr_constrainttarget ()
| Converts this widget to a reference counted Gtk::ConstraintTarget.
Glib::RefPtr< const ConstraintTarget > | make_refptr_constrainttarget () const
| Converts this widget to a reference counted Gtk::ConstraintTarget.
void | show ()
| Flags a widget to be displayed.
void | hide ()
| Reverses the effects of [method.Gtk.Widget.show].
void | queue_draw ()
| Schedules this widget to be redrawn.
void | queue_resize ()
| Flags a widget to have its size renegotiated.
void | queue_allocate ()
| Flags the widget for a rerun of the size_allocate_vfunc() function.
void | size_allocate (const Allocation & allocation, int baseline)
| Allocates widget with a transformation that translates the origin to the position in allocation.
SizeRequestMode | get_request_mode () const
| Gets whether the widget prefers a height-for-width layout or a width-for-height layout.
void | measure (Orientation orientation, int for_size, int & minimum, int & natural, int & minimum_baseline, int & natural_baseline) const
| Measures widget in the orientation orientation and for the given for_size.
Measurements | measure (Orientation orientation, int for_size=-1) const
| Like the other overload of measure() but returns a structure holding the sizes/baselines instead of using output parameters.
void | get_preferred_size (Requisition & minimum_size, Requisition & natural_size) const
| Retrieves the minimum and natural size of a widget, taking into account the widget’s preference for height-for-width management.
PreferredSize | get_preferred_size () const
| Like the other overload of get_preferred_size() but returns a structure holding the sizes instead of using output parameters.
void | set_layout_manager (const Glib::RefPtr< LayoutManager > & layout_manager)
| Sets the layout manager to use for measuring and allocating children of the widget.
void | unset_layout_manager ()
| Undoes the effect of a previous call to set_layout_manager().
Glib::RefPtr< LayoutManager > | get_layout_manager ()
| Retrieves the layout manager of the widget.
Glib::RefPtr< const LayoutManager > | get_layout_manager () const
| Retrieves the layout manager of the widget.
bool | mnemonic_activate (bool group_cycling)
| Emits the signal_mnemonic_activate() signal.
bool | activate ()
| For widgets that can be “activated” (buttons, menu items, etc.) this function activates them.
void | set_can_focus (bool can_focus=true)
| Sets whether the input focus can enter the widget or any of its children.
bool | get_can_focus () const
| Determines whether the input focus can enter the widget or any of its children.
void | set_focusable (bool focusable=true)
| Sets whether the widget can own the input focus.
bool | get_focusable () const
| Determines whether the widget can own the input focus.
bool | has_focus () const
| Determines if the widget has the global input focus.
bool | is_focus () const
| Determines if the widget is the focus widget within its toplevel.
bool | has_visible_focus () const
| Determines if the widget should show a visible indication that it has the global input focus.
bool | grab_focus ()
| Causes widget to have the keyboard focus for the window that it belongs to.
void | set_focus_on_click (bool focus_on_click=true)
| Sets whether the widget should grab focus when it is clicked with the mouse.
bool | get_focus_on_click () const
| Returns whether the widget should grab focus when it is clicked with the mouse.
void | set_can_target (bool can_target=true)
| Sets whether the widget can be the target of pointer events.
bool | get_can_target () const
| Queries whether the widget can be the target of pointer events.
bool | has_default () const
| Determines whether the widget is the current default widget within its toplevel.
void | set_receives_default (bool receives_default=true)
| Sets whether the widget will be treated as the default widget within its toplevel when it has the focus, even if another widget is the default.
bool | get_receives_default () const
| Determines whether the widget is always treated as the default widget within its toplevel when it has the focus, even if another widget is the default.
void | set_name (const Glib::ustring & name)
| Sets a widgets name.
void | unset_name ()
Glib::ustring | get_name () const
| Retrieves the name of a widget.
void | set_state_flags (StateFlags flags, bool clear=true)
| Turns on flag values in the current widget state.
void | unset_state_flags (StateFlags flags)
| Turns off flag values for the current widget state.
StateFlags | get_state_flags () const
| Returns the widget state as a flag set.
void | set_sensitive (bool sensitive=true)
| Sets the sensitivity of the widget.
bool | get_sensitive () const
| Returns the widget’s sensitivity.
bool | is_sensitive () const
| Returns the widget’s effective sensitivity.
void | set_visible (bool visible=true)
| Sets the visibility state of widget.
bool | get_visible () const
| Determines whether the widget is visible.
bool | is_visible () const
| Determines whether the widget and all its parents are marked as visible.
bool | is_drawable () const
| Determines whether the widget can be drawn to.
bool | get_realized () const
| Determines whether the widget is realized.
bool | get_mapped () const
| Returns whether the widget is mapped.
void | set_child_visible (bool visible=true)
| Sets whether the widget should be mapped along with its parent.
bool | get_child_visible () const
| Gets the value set with set_child_visible().
int | get_allocated_width () const
| Returns the width that has currently been allocated to the widget.
int | get_allocated_height () const
| Returns the height that has currently been allocated to the widget.
int | get_allocated_baseline () const
| Returns the baseline that has currently been allocated to the widget.
Allocation | get_allocation () const
| Retrieves the widget’s location.
std::optional< Gdk::Graphene::Rect > | compute_bounds (const Widget & target) const
| Computes the bounds for the widget in the coordinate space of target.
std::optional< Gdk::Graphene::Point > | compute_point (const Widget & target, const Gdk::Graphene::Point & point) const
| Translates the given point in the widget's coordinates to coordinates relative to target’s coordinate system.
int | get_width () const
| Returns the content width of the widget.
int | get_height () const
| Returns the content height of the widget.
int | get_baseline () const
| Returns the baseline that has currently been allocated to the widget.
int | get_size (Orientation orientation) const
| Returns the content width or height of the widget.
Widget * | get_parent ()
| Returns the parent widget of the widget.
const Widget * | get_parent () const
| Returns the parent widget of the widget.
Root * | get_root ()
| Returns the Gtk::Root widget of the widget.
const Root * | get_root () const
| Returns the Gtk::Root widget of the widget.
Native * | get_native ()
| Returns the nearest Gtk::Native ancestor of the widget.
const Native * | get_native () const
| Returns the nearest Gtk::Native ancestor of the widget.
bool | child_focus (DirectionType direction)
| Called by widgets as the user moves around the window using keyboard shortcuts.
bool | keynav_failed (DirectionType direction)
| Emits the signal_keynav_failed() signal on the widget.
void | error_bell ()
| Notifies the user about an input-related error on the widget.
void | set_size_request (int width=-1, int height=-1)
| Sets the minimum size of the widget.
void | get_size_request (int & width, int & height) const
| Gets the size request that was explicitly set for the widget.
Requisition | get_size_request () const
| Like the other overload of get_size_request() but returns a structure holding the sizes instead of using output parameters.
void | set_opacity (double opacity)
| Requests the widget to be rendered partially transparent.
double | get_opacity () const
| Fetches the requested opacity for the widget.
void | set_overflow (Overflow overflow)
| Sets how the widget treats content that is drawn outside the it's content area.
Overflow | get_overflow () const
| Returns the widget’s overflow value.
Widget * | get_ancestor (GType widget_type)
| Gets the first ancestor of the widget with type widget_type.
const Widget * | get_ancestor (GType widget_type) const
| Gets the first ancestor of the widget with type widget_type.
int | get_scale_factor () const
| Retrieves the internal scale factor that maps from window coordinates to the actual device pixels.
Glib::RefPtr< Gdk::Display > | get_display ()
| Get the display for the window that the widget belongs to.
Glib::RefPtr< const Gdk::Display > | get_display () const
| Get the display for the window that the widget belongs to.
Glib::RefPtr< Settings > | get_settings ()
| Gets the settings object holding the settings used for the widget.
Glib::RefPtr< Gdk::Clipboard > | get_clipboard ()
| Gets the clipboard object for the widget.
Glib::RefPtr< const Gdk::Clipboard > | get_clipboard () const
| Gets the clipboard object for the widget.
Glib::RefPtr< Gdk::Clipboard > | get_primary_clipboard ()
| Gets the primary clipboard of the widget.
Glib::RefPtr< const Gdk::Clipboard > | get_primary_clipboard () const
| Gets the primary clipboard of the widget.
bool | get_hexpand () const
| Gets whether the widget would like any available extra horizontal space.
void | set_hexpand (bool expand=true)
| Sets whether the widget would like any available extra horizontal space.
bool | get_hexpand_set () const
| Gets whether the hexpand flag has been explicitly set.
void | set_hexpand_set (bool set=true)
| Sets whether the hexpand flag will be used.
bool | get_vexpand () const
| Gets whether the widget would like any available extra vertical space.
void | set_vexpand (bool expand=true)
| Sets whether the widget would like any available extra vertical space.
bool | get_vexpand_set () const
| Gets whether the vexpand flag has been explicitly set.
void | set_vexpand_set (bool set=true)
| Sets whether the vexpand flag will be used.
bool | compute_expand (Orientation orientation)
| Computes whether a parent widget should give this widget extra space when possible.
void | set_expand (bool expand=true)
| Sets whether the widget would like any available extra space in both directions.
Align | get_halign () const
| Gets the horizontal alignment of the widget.
void | set_halign (Align align)
| Sets the horizontal alignment of the widget.
Align | get_valign () const
| Gets the vertical alignment of the widget.
void | set_valign (Align align)
| Sets the vertical alignment of the widget.
int | get_margin_start () const
| Gets the start margin of the widget.
void | set_margin_start (int margin)
| Sets the start margin of the widget.
int | get_margin_end () const
| Gets the end margin of the widget.
void | set_margin_end (int margin)
| Sets the end margin of the widget.
int | get_margin_top () const
| Gets the top margin of the widget.
void | set_margin_top (int margin)
| Sets the top margin of the widget.
int | get_margin_bottom () const
| Gets the bottom margin of the widget.
void | set_margin_bottom (int margin)
| Sets the bottom margin of the widget.
void | set_margin (int margin)
| Set all 4 margins to the same value.
bool | is_ancestor (Widget & ancestor) const
| Determines whether the widget is a descendent of ancestor.
bool | translate_coordinates (Widget & dest_widget, double src_x, double src_y, double & dest_x, double & dest_y)
| Translates coordinates relative to src_widget’s allocation to coordinates relative to dest_widget’s allocations.
bool | contains (double x, double y) const
| Tests if a given point is contained in the widget.
Widget * | pick (double x, double y, PickFlags flags=PickFlags::DEFAULT)
| Finds the descendant of the widget closest to a point.
const Widget * | pick (double x, double y, PickFlags flags=PickFlags::DEFAULT) const
| Finds the descendant of the widget closest to a point.
void | add_controller (const Glib::RefPtr< EventController > & controller)
| Adds an event controller to the widget.
void | remove_controller (const Glib::RefPtr< EventController > & controller)
| Removes an event controller from the widget.
Glib::RefPtr< Pango::Context > | create_pango_context ()
| Creates a new Pango::Context that is configured for the widget.
Glib::RefPtr< Pango::Context > | get_pango_context ()
| Gets a Pango::Context that is configured for the widget.
void | set_font_options (const Cairo::FontOptions & options)
| Sets the cairo_font_options_t used for text rendering in the widget.
void | unset_font_options ()
| Undoes the effect of previous calls to set_font_options().
Cairo::FontOptions | get_font_options () const
| Returns the cairo_font_options_t of the widget.
Glib::RefPtr< Pango::Layout > | create_pango_layout (const Glib::ustring & text)
| Creates a new Pango::Layout that is configured for the widget.
void | set_direction (TextDirection dir)
| Sets the reading direction on the widget.
TextDirection | get_direction () const
| Gets the reading direction for the widget.
void | set_cursor (const Glib::RefPtr< Gdk::Cursor > & cursor)
| Sets the cursor to be shown when the pointer hovers over the widget.
void | set_cursor (const Glib::ustring & name={})
| Sets a named cursor to be shown when pointer devices point towards the widget.
Glib::RefPtr< Gdk::Cursor > | get_cursor ()
| Gets the cursor set on the widget.
Glib::RefPtr< const Gdk::Cursor > | get_cursor () const
| Gets the cursor set on the widget.
std::vector< Widget * > | list_mnemonic_labels ()
| Returns the widgets for which this widget is the target of a mnemonic.
std::vector< const Widget * > | list_mnemonic_labels () const
| Returns the widgets for which this widget is the target of a mnemonic.
void | add_mnemonic_label (Widget & label)
| Adds a widget to the list of mnemonic labels for this widget.
void | remove_mnemonic_label (Widget & label)
| Removes a widget from the list of mnemonic labels for this widget.
bool | drag_check_threshold (int start_x, int start_y, int current_x, int current_y)
| Checks to see if a drag movement has passed the GTK drag threshold.
Glib::RefPtr< Gdk::FrameClock > | get_frame_clock ()
| Obtains the frame clock for a widget.
Glib::RefPtr< const Gdk::FrameClock > | get_frame_clock () const
| Obtains the frame clock for a widget.
void | set_parent (Widget & parent)
| Sets the parent widget of the widget.
void | unparent ()
| Removes widget from its parent.
void | map ()
| Causes a widget to be mapped if it isn’t already.
void | unmap ()
| Causes a widget to be unmapped if it’s currently mapped.
void | trigger_tooltip_query ()
| Triggers a tooltip query on the display of the widget.
void | set_tooltip_text (const Glib::ustring & text)
| Sets the contents of the tooltip for the widget.
Glib::ustring | get_tooltip_text () const
| Gets the contents of the tooltip for the widget.
void | set_tooltip_markup (const Glib::ustring & markup)
| Sets the contents of the tooltip for widget.
Glib::ustring | get_tooltip_markup () const
| Gets the contents of the tooltip for the widget.
void | set_has_tooltip (bool has_tooltip=TRUE)
| Sets the has-tooltip property on the widget.
bool | get_has_tooltip () const
| Returns the current value of the has-tooltip property.
bool | in_destruction () const
| Returns whether the widget is currently being destroyed.
Glib::RefPtr< StyleContext > | get_style_context ()
| Returns the style context associated to the widget.
Glib::RefPtr< const StyleContext > | get_style_context () const
| Returns the style context associated to the widget.
guint | add_tick_callback (const SlotTick & slot)
| Queues an animation frame update and adds a callback to be called before each frame.
void | remove_tick_callback (guint id)
| Removes a tick callback previously registered with add_tick_callback().
void | insert_action_group (const Glib::ustring & name, const Glib::RefPtr< Gio::ActionGroup > & group)
| Inserts an action group into the widget's actions.
void | remove_action_group (const Glib::ustring & name)
| Removes a group from the widget.
bool | activate_action (const Glib::ustring & name, const Glib::VariantBase & args={})
| Looks up the action in the action groups associated with the widget and its ancestors, and activates it.
void | activate_default ()
| Activates the default.activate action for the widget.
void | set_font_map (const Glib::RefPtr< Pango::FontMap > & font_map)
| Sets the font map to use for text rendering in the widget.
Glib::RefPtr< Pango::FontMap > | get_font_map ()
| Gets the font map of the widget.
Glib::RefPtr< const Pango::FontMap > | get_font_map () const
| Gets the font map of the widget.
Widget * | get_first_child ()
| Returns the widget’s first child.
const Widget * | get_first_child () const
| Returns the widget’s first child.
Widget * | get_last_child ()
| Returns the widget’s last child.
const Widget * | get_last_child () const
| Returns the widget’s last child.
Widget * | get_next_sibling ()
| Returns the widget’s next sibling.
const Widget * | get_next_sibling () const
| Returns the widget’s next sibling.
Widget * | get_prev_sibling ()
| Returns the widget’s previous sibling.
const Widget * | get_prev_sibling () const
| Returns the widget’s previous sibling.
std::vector< Widget * > | get_children ()
| Gets a vector of the widgetʼs current children, from first child to last.
std::vector< const Widget * > | get_children () const
| Gets a vector of the widgetʼs current children, from first child to last.
Glib::RefPtr< Gio::ListModel > | observe_children ()
| Returns a list model to track the children of the widget.
Glib::RefPtr< const Gio::ListModel > | observe_children () const
| Returns a list model to track the children of the widget.
Glib::RefPtr< Gio::ListModel > | observe_controllers ()
| Returns a list model to track the event controllers of the widget.
Glib::RefPtr< const Gio::ListModel > | observe_controllers () const
| Returns a list model to track the event controllers of the widget.
void | insert_after (Widget & parent, const Widget & previous_sibling)
| Inserts the Widget into the child widget list of parent after previous_sibling.
void | insert_before (Widget & parent, const Widget & next_sibling)
| Inserts the Widget into the child widget list of parent before next_sibling.
void | insert_at_start (Widget & parent)
| Inserts the Widget at the beginning of the child widget list of parent.
void | insert_at_end (Widget & parent)
| Inserts the Widget at the end of the child widget list of parent.
void | snapshot_child (Widget & child, const Glib::RefPtr< Gtk::Snapshot > & snapshot)
| Snapshots a child of the widget.
bool | should_layout () const
| Returns whether the widget should contribute to the measuring and allocation of its parent.
Glib::ustring | get_css_name () const
| Returns the CSS name of the widget.
void | add_css_class (const Glib::ustring & css_class)
| Adds a style class to the widget.
void | remove_css_class (const Glib::ustring & css_class)
| Removes a style from the widget.
bool | has_css_class (const Glib::ustring & css_class) const
| Returns whether a style class is currently applied to the widget.
std::vector< Glib::ustring > | get_css_classes () const
| Returns the list of style classes applied to the widget.
void | set_css_classes (const std::vector< Glib::ustring > & classes)
| Replaces the current style classes of the widget with classes.
Gdk::RGBA | get_color () const
| Gets the current foreground color for the widget's CSS style.
void | set_limit_events (bool limit_events=true)
| Sets whether the widget acts like a modal dialog, with respect to event delivery.
bool | get_limit_events () const
| Gets the value of the property_limit_events() property.
Glib::SignalProxy< void()> | signal_show ()
Glib::SignalProxy< void()> | signal_hide ()
Glib::SignalProxy< void()> | signal_map ()
| Emitted on mapping of a widget to the screen.
Glib::SignalProxy< void()> | signal_unmap ()
Glib::SignalProxy< void()> | signal_realize ()
| Emitted on realization of a widget.
Glib::SignalProxy< void()> | signal_unrealize ()
Glib::SignalProxy< void(Gtk::StateFlags)> | signal_state_flags_changed ()
Glib::SignalProxy< void(TextDirection)> | signal_direction_changed ()
Glib::SignalProxy< bool(bool)> | signal_mnemonic_activate ()
Glib::SignalProxy< void()> | signal_destroy ()
| Emitted during the dispose phase.
Glib::SignalProxy< bool(int, int, bool, const Glib::RefPtr< Tooltip > &)> | signal_query_tooltip ()
Glib::PropertyProxy< Glib::ustring > | property_name ()
| The name of the widget.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_name () const
| The name of the widget.
Glib::PropertyProxy_ReadOnly< Widget * > | property_parent () const
| The parent widget of this widget.
Glib::PropertyProxy_ReadOnly< Root * > | property_root () const
| The Gtk::Root widget of the widget tree containing this widget.
Glib::PropertyProxy< int > | property_width_request ()
| Overrides for width request of the widget.
Glib::PropertyProxy_ReadOnly< int > | property_width_request () const
| Overrides for width request of the widget.
Glib::PropertyProxy< int > | property_height_request ()
| Overrides for height request of the widget.
Glib::PropertyProxy_ReadOnly< int > | property_height_request () const
| Overrides for height request of the widget.
Glib::PropertyProxy< bool > | property_visible ()
| Whether the widget is visible.
Glib::PropertyProxy_ReadOnly< bool > | property_visible () const
| Whether the widget is visible.
Glib::PropertyProxy< bool > | property_sensitive ()
| Whether the widget responds to input.
Glib::PropertyProxy_ReadOnly< bool > | property_sensitive () const
| Whether the widget responds to input.
Glib::PropertyProxy< bool > | property_can_focus ()
| Whether the widget or any of its descendents can accept the input focus.
Glib::PropertyProxy_ReadOnly< bool > | property_can_focus () const
| Whether the widget or any of its descendents can accept the input focus.
Glib::PropertyProxy_ReadOnly< bool > | property_has_focus () const
| Whether the widget has the input focus.
Glib::PropertyProxy< bool > | property_can_target ()
| Whether the widget can receive pointer events.
Glib::PropertyProxy_ReadOnly< bool > | property_can_target () const
| Whether the widget can receive pointer events.
Glib::PropertyProxy< bool > | property_focus_on_click ()
| Whether the widget should grab focus when it is clicked with the mouse.
Glib::PropertyProxy_ReadOnly< bool > | property_focus_on_click () const
| Whether the widget should grab focus when it is clicked with the mouse.
Glib::PropertyProxy< bool > | property_focusable ()
| Whether this widget itself will accept the input focus.
Glib::PropertyProxy_ReadOnly< bool > | property_focusable () const
| Whether this widget itself will accept the input focus.
Glib::PropertyProxy_ReadOnly< bool > | property_has_default () const
| Whether the widget is the default widget.
Glib::PropertyProxy< bool > | property_receives_default ()
| Whether the widget will receive the default action when it is focused.
Glib::PropertyProxy_ReadOnly< bool > | property_receives_default () const
| Whether the widget will receive the default action when it is focused.
Glib::PropertyProxy< Glib::RefPtr< Gdk::Cursor > > | property_cursor ()
| The cursor used by widget.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gdk::Cursor > > | property_cursor () const
| The cursor used by widget.
Glib::PropertyProxy< bool > | property_has_tooltip ()
| Enables or disables the emission of the signal_query_tooltip() signal on widget.
Glib::PropertyProxy_ReadOnly< bool > | property_has_tooltip () const
| Enables or disables the emission of the signal_query_tooltip() signal on widget.
Glib::PropertyProxy< Glib::ustring > | property_tooltip_markup ()
| Sets the text of tooltip to be the given string, which is marked up with Pango markup.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_tooltip_markup () const
| Sets the text of tooltip to be the given string, which is marked up with Pango markup.
Glib::PropertyProxy< Glib::ustring > | property_tooltip_text ()
| Sets the text of tooltip to be the given string.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_tooltip_text () const
| Sets the text of tooltip to be the given string.
Glib::PropertyProxy< Align > | property_halign ()
| How to distribute horizontal space if widget gets extra space.
Glib::PropertyProxy_ReadOnly< Align > | property_halign () const
| How to distribute horizontal space if widget gets extra space.
Glib::PropertyProxy< Align > | property_valign ()
| How to distribute vertical space if widget gets extra space.
Glib::PropertyProxy_ReadOnly< Align > | property_valign () const
| How to distribute vertical space if widget gets extra space.
Glib::PropertyProxy< int > | property_margin_start ()
| Margin on start of widget, horizontally.
Glib::PropertyProxy_ReadOnly< int > | property_margin_start () const
| Margin on start of widget, horizontally.
Glib::PropertyProxy< int > | property_margin_end ()
| Margin on end of widget, horizontally.
Glib::PropertyProxy_ReadOnly< int > | property_margin_end () const
| Margin on end of widget, horizontally.
Glib::PropertyProxy< int > | property_margin_top ()
| Margin on top side of widget.
Glib::PropertyProxy_ReadOnly< int > | property_margin_top () const
| Margin on top side of widget.
Glib::PropertyProxy< int > | property_margin_bottom ()
| Margin on bottom side of widget.
Glib::PropertyProxy_ReadOnly< int > | property_margin_bottom () const
| Margin on bottom side of widget.
Glib::PropertyProxy< bool > | property_hexpand ()
| Whether to expand horizontally.
Glib::PropertyProxy_ReadOnly< bool > | property_hexpand () const
| Whether to expand horizontally.
Glib::PropertyProxy< bool > | property_hexpand_set ()
| Whether to use the hexpand property.
Glib::PropertyProxy_ReadOnly< bool > | property_hexpand_set () const
| Whether to use the hexpand property.
Glib::PropertyProxy< bool > | property_vexpand ()
| Whether to expand vertically.
Glib::PropertyProxy_ReadOnly< bool > | property_vexpand () const
| Whether to expand vertically.
Glib::PropertyProxy< bool > | property_vexpand_set ()
| Whether to use the vexpand property.
Glib::PropertyProxy_ReadOnly< bool > | property_vexpand_set () const
| Whether to use the vexpand property.
Glib::PropertyProxy< double > | property_opacity ()
| The requested opacity of the widget.
Glib::PropertyProxy_ReadOnly< double > | property_opacity () const
| The requested opacity of the widget.
Glib::PropertyProxy< Overflow > | property_overflow ()
| How content outside the widget's content area is treated.
Glib::PropertyProxy_ReadOnly< Overflow > | property_overflow () const
| How content outside the widget's content area is treated.
Glib::PropertyProxy_ReadOnly< int > | property_scale_factor () const
| The scale factor of the widget.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_css_name () const
| The name of this widget in the CSS tree.
Glib::PropertyProxy< std::vector< Glib::ustring > > | property_css_classes ()
| A list of css classes applied to this widget.
Glib::PropertyProxy_ReadOnly< std::vector< Glib::ustring > > | property_css_classes () const
| A list of css classes applied to this widget.
Glib::PropertyProxy< Glib::RefPtr< LayoutManager > > | property_layout_manager ()
| The Gtk::LayoutManager instance to use to compute the preferred size of the widget, and allocate its children.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< LayoutManager > > | property_layout_manager () const
| The Gtk::LayoutManager instance to use to compute the preferred size of the widget, and allocate its children.
Glib::PropertyProxy< bool > | property_limit_events ()
| Makes this widget act like a modal dialog, with respect to event delivery.
Glib::PropertyProxy_ReadOnly< bool > | property_limit_events () const
| Makes this widget act like a modal dialog, with respect to event delivery.
Public Member Functions inherited from Gtk::Object
| Object (Object && src) noexcept
Object & | operator= (Object && src) noexcept
| ~Object () noexcept override
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data_with_c_callback (const Quark &key, void *data, GDestroyNotify notify)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const
Public Member Functions inherited from Gtk::Accessible
| Accessible (Accessible && src) noexcept
Accessible & | operator= (Accessible && src) noexcept
| ~Accessible () noexcept override
GtkAccessible * | gobj ()
| Provides access to the underlying C GObject.
const GtkAccessible * | gobj () const
| Provides access to the underlying C GObject.
Glib::RefPtr< ATContext > | get_at_context ()
| Retrieves the implementation for the given accessible object.
Glib::RefPtr< const ATContext > | get_at_context () const
| Retrieves the implementation for the given accessible object.
bool | get_platform_state (PlatformState state) const
| Queries a platform state, such as focus.
void | update_platform_state (PlatformState state)
| Informs ATs that the platform state has changed.
Glib::RefPtr< Accessible > | get_accessible_parent ()
| Retrieves the accessible parent for an accessible object.
Glib::RefPtr< const Accessible > | get_accessible_parent () const
| Retrieves the accessible parent for an accessible object.
void | set_accessible_parent (const Glib::RefPtr< Accessible > & parent, const Glib::RefPtr< Accessible > & next_sibling)
| Sets the parent and sibling of an accessible object.
Glib::RefPtr< Accessible > | get_first_accessible_child ()
| Retrieves the first accessible child of an accessible object.
Glib::RefPtr< const Accessible > | get_first_accessible_child () const
| Retrieves the first accessible child of an accessible object.
Glib::RefPtr< Accessible > | get_next_accessible_sibling ()
| Retrieves the next accessible sibling of an accessible object.
Glib::RefPtr< const Accessible > | get_next_accessible_sibling () const
| Retrieves the next accessible sibling of an accessible object.
void | update_next_accessible_sibling (const Glib::RefPtr< Accessible > & new_sibling)
| Updates the next accessible sibling.
bool | get_bounds (int & x, int & y, int & width, int & height) const
| Queries the coordinates and dimensions of this accessible.
Glib::ustring | get_accessible_id () const
| Retrieves the accessible identifier for the accessible object.
Role | get_accessible_role () const
| Retrieves the accessible role of an accessible object.
void | update_state (State state, const Glib::ValueBase & value)
| Updates an accessible state.
void | update_property (Property property, const Glib::ValueBase & value)
| Updates an accessible property.
void | update_relation (Relation relation, const Glib::ValueBase & value)
| Updates an accessible relation.
void | reset_state (State state)
| Resets the accessible state to its default value.
void | reset_property (Property property)
| Resets the accessible property to its default value.
void | reset_relation (Relation relation)
| Resets the accessible relation to its default value.
void | announce (const Glib::ustring & message, AnnouncementPriority priority)
| Requests the user's screen reader to announce the given message.
Glib::PropertyProxy< Role > | property_accessible_role ()
| The accessible role of the given Gtk::Accessible implementation.
Glib::PropertyProxy_ReadOnly< Role > | property_accessible_role () const
| The accessible role of the given Gtk::Accessible implementation.
Public Member Functions inherited from Glib::Interface
| Interface ()
| Interface (Interface &&src) noexcept
Interface & | operator= (Interface &&src) noexcept
| Interface (const Glib::Interface_Class &interface_class)
| Interface (GObject *castitem)
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const
Public Member Functions inherited from Gtk::Buildable
| Buildable (Buildable && src) noexcept
Buildable & | operator= (Buildable && src) noexcept
| ~Buildable () noexcept override
GtkBuildable * | gobj ()
| Provides access to the underlying C GObject.
const GtkBuildable * | gobj () const
| Provides access to the underlying C GObject.
Glib::ustring | get_buildable_id () const
| Gets the ID of the buildable object.
Public Member Functions inherited from Gtk::ConstraintTarget
| ConstraintTarget (ConstraintTarget && src) noexcept
ConstraintTarget & | operator= (ConstraintTarget && src) noexcept
| ~ConstraintTarget () noexcept override
GtkConstraintTarget * | gobj ()
| Provides access to the underlying C GObject.
const GtkConstraintTarget * | gobj () const
| Provides access to the underlying C GObject.

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::Widget
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static void | set_default_direction (TextDirection dir)
| Sets the default reading direction for widgets.
static TextDirection | get_default_direction ()
| Obtains the default reading direction.
Static Public Member Functions inherited from Gtk::Accessible
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::Buildable
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::ConstraintTarget
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.

## Related Symbols
(Note that these are not member symbols.)
Gtk::ScrolledWindow * | wrap (GtkScrolledWindow * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::Widget
Gtk::Widget * | wrap (GtkWidget * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::Accessible
Glib::RefPtr< Gtk::Accessible > | wrap (GtkAccessible * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::Buildable
Glib::RefPtr< Gtk::Buildable > | wrap (GtkBuildable * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::ConstraintTarget
Glib::RefPtr< Gtk::ConstraintTarget > | wrap (GtkConstraintTarget * object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Additional Inherited Members
Public Types inherited from Gtk::Widget
using | PreferredSize = MinimumNatural<Requisition>
| Structure returned by the non-output-parameter overload of get_preferred_size().
using | SlotTick = sigc::slot<bool(const Glib::RefPtr<Gdk::FrameClock>&)>
| Callback type for adding a function to update animations.
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from Gtk::Accessible
enum class | Role { Role::ALERT , Role::ALERT_DIALOG , Role::BANNER , Role::BUTTON , Role::CAPTION , Role::CELL , Role::CHECKBOX , Role::COLUMN_HEADER , Role::COMBO_BOX , Role::COMMAND , Role::COMPOSITE , Role::DIALOG , Role::DOCUMENT , Role::FEED , Role::FORM , Role::GENERIC , Role::GRID , Role::GRID_CELL , Role::GROUP , Role::HEADING , Role::IMG , Role::INPUT , Role::LABEL , Role::LANDMARK , Role::LEGEND , Role::LINK , Role::LIST , Role::LIST_BOX , Role::LIST_ITEM , Role::LOG , Role::MAIN , Role::MARQUEE , Role::MATH , Role::METER , Role::MENU , Role::MENU_BAR , Role::MENU_ITEM , Role::MENU_ITEM_CHECKBOX , Role::MENU_ITEM_RADIO , Role::NAVIGATION , Role::NONE , Role::NOTE , Role::OPTION , Role::PRESENTATION , Role::PROGRESS_BAR , Role::RADIO , Role::RADIO_GROUP , Role::RANGE , Role::REGION , Role::ROW , Role::ROW_GROUP , Role::ROW_HEADER , Role::SCROLLBAR , Role::SEARCH , Role::SEARCH_BOX , Role::SECTION , Role::SECTION_HEAD , Role::SELECT , Role::SEPARATOR , Role::SLIDER , Role::SPIN_BUTTON , Role::STATUS , Role::STRUCTURE , Role::SWITCH , Role::TAB , Role::TABLE , Role::TAB_LIST , Role::TAB_PANEL , Role::TEXT_BOX , Role::TIME , Role::TIMER , Role::TOOLBAR , Role::TOOLTIP , Role::TREE , Role::TREE_GRID , Role::TREE_ITEM , Role::WIDGET , Role::WINDOW , Role::TOGGLE_BUTTON , Role::APPLICATION , Role::PARAGRAPH , Role::BLOCK_QUOTE , Role::ARTICLE , Role::COMMENT , Role::TERMINAL }
| The accessible role for a Gtk::Accessible implementation. More...
enum class | State { State::BUSY , State::CHECKED , State::DISABLED , State::EXPANDED , State::HIDDEN , State::INVALID , State::PRESSED , State::SELECTED , State::VISITED }
| The possible accessible states of a Gtk::Accessible. More...
enum class | Property { Property::AUTOCOMPLETE , Property::DESCRIPTION , Property::HAS_POPUP , Property::KEY_SHORTCUTS , Property::LABEL , Property::LEVEL , Property::MODAL , Property::MULTI_LINE , Property::MULTI_SELECTABLE , Property::ORIENTATION , Property::PLACEHOLDER , Property::READ_ONLY , Property::REQUIRED , Property::ROLE_DESCRIPTION , Property::SORT , Property::VALUE_MAX , Property::VALUE_MIN , Property::VALUE_NOW , Property::VALUE_TEXT , Property::HELP_TEXT }
| The possible accessible properties of a Gtk::Accessible. More...
enum class | Relation { Relation::ACTIVE_DESCENDANT , Relation::COL_COUNT , Relation::COL_INDEX , Relation::COL_INDEX_TEXT , Relation::COL_SPAN , Relation::CONTROLS , Relation::DESCRIBED_BY , Relation::DETAILS , Relation::ERROR_MESSAGE , Relation::FLOW_TO , Relation::LABELLED_BY , Relation::OWNS , Relation::POS_IN_SET , Relation::ROW_COUNT , Relation::ROW_INDEX , Relation::ROW_INDEX_TEXT , Relation::ROW_SPAN , Relation::SET_SIZE , Relation::LABEL_FOR , Relation::DESCRIPTION_FOR , Relation::CONTROLLED_BY , Relation::DETAILS_FOR , Relation::ERROR_MESSAGE_FOR , Relation::FLOW_FROM }
| The possible accessible relations of a Gtk::Accessible. More...
enum class | PlatformState { PlatformState::FOCUSABLE , PlatformState::FOCUSED , PlatformState::ACTIVE }
| The various platform states which can be queried using Gtk::Accessible::get_platform_state(). More...
enum class | AnnouncementPriority { AnnouncementPriority::LOW , AnnouncementPriority::MEDIUM , AnnouncementPriority::HIGH }
| The priority of an accessibility announcement. More...
Protected Member Functions inherited from Gtk::Widget
virtual void | root_vfunc ()
virtual void | unroot_vfunc ()
virtual void | size_allocate_vfunc (int width, int height, int baseline)
virtual SizeRequestMode | get_request_mode_vfunc () const
virtual void | measure_vfunc (Orientation orientation, int for_size, int & minimum, int & natural, int & minimum_baseline, int & natural_baseline) const
virtual bool | grab_focus_vfunc ()
virtual void | set_focus_child_vfunc (Widget * child)
| Sets the focused child of widget.
virtual void | compute_expand_vfunc (bool & hexpand_p, bool & vexpand_p)
virtual bool | contains_vfunc (double x, double y) const
virtual void | snapshot_vfunc (const Glib::RefPtr< Gtk::Snapshot > & snapshot)
| Widget ()
void | realize ()
| Creates the GDK resources associated with a widget.
void | unrealize ()
| Causes a widget to be unrealized.
void | realize_if_needed ()
void | set_focus_child (Widget & child)
| Set the focus child of the widget.
void | unset_focus_child ()
| Unsets the focus child of the widget.
Widget * | get_focus_child ()
| Returns the focus child of the widget.
const Widget * | get_focus_child () const
| Returns the focus child of the widget.
virtual void | on_show ()
| This is a default handler for the signal signal_show().
virtual void | on_hide ()
| This is a default handler for the signal signal_hide().
virtual void | on_map ()
| This is a default handler for the signal signal_map().
virtual void | on_unmap ()
| This is a default handler for the signal signal_unmap().
virtual void | on_realize ()
| This is a default handler for the signal signal_realize().
virtual void | on_unrealize ()
| This is a default handler for the signal signal_unrealize().
virtual void | on_state_flags_changed (Gtk::StateFlags previous_state_flags)
| This is a default handler for the signal signal_state_flags_changed().
virtual void | on_direction_changed (TextDirection direction)
| This is a default handler for the signal signal_direction_changed().
virtual bool | on_mnemonic_activate (bool group_cycling)
| This is a default handler for the signal signal_mnemonic_activate().
virtual bool | on_query_tooltip (int x, int y, bool keyboard_tooltip, const Glib::RefPtr< Tooltip > & tooltip)
| This is a default handler for the signal signal_query_tooltip().
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)
Protected Member Functions inherited from Gtk::Accessible
| Accessible ()
| You should derive from this class to use it.
Protected Member Functions inherited from Gtk::Buildable
| Buildable ()
| You should derive from this class to use it.
Protected Member Functions inherited from Gtk::ConstraintTarget
| ConstraintTarget ()
| You should derive from this class to use it.

## Detailed Description

A container that makes its child scrollable.

It does so using either internally added scrollbars or externally associated adjustments, and optionally draws a frame around the child.

Widgets with native scrolling support, i.e. those whose classes implement the Gtk::Scrollable interface, are added directly. For other types of widget, the class Gtk::Viewport acts as an adaptor, giving scrollability to other widgets. set_child() intelligently accounts for whether or not the added child is a Gtk::Scrollable. If it isn’t, then it wraps the child in a Gtk::Viewport. Therefore, you can just add any child widget and not worry about the details. If set_child() has added a Gtk::Viewport for you, it will be automatically removed when you unset the child.

Unless property_hscrollbar_policy() and property_vscrollbar_policy() are Gtk::PolicyType::NEVER or Gtk::PolicyType::EXTERNAL, Gtk::ScrolledWindow adds internal Gtk::Scrollbar widgets around its child. The scroll position of the child, and if applicable the scrollbars, is controlled by the property_hadjustment() and property_vadjustment() that are associated with the Gtk::ScrolledWindow. See the docs on Gtk::Scrollbar for the details, but note that the “step_increment” and “page_increment” fields are only effective if the policy causes scrollbars to be present.

If a Gtk::ScrolledWindow doesn’t behave quite as you would like, or doesn’t have exactly the right layout, it’s very possible to set up your own scrolling with Gtk::Scrollbar and for example a Gtk::Grid.

# Touch support

Gtk::ScrolledWindow has built-in support for touch devices. When a touchscreen is used, swiping will move the scrolled window, and will expose 'kinetic' behavior. This can be turned off with property_kinetic_scrolling() if it is undesired.

Gtk::ScrolledWindow also displays visual 'overshoot' indication when the content is pulled beyond the end, and this situation can be captured with signal_edge_overshot().

If no mouse device is present, the scrollbars will be overlaid as narrow, auto-hiding indicators over the content. If traditional scrollbars are desired although no mouse is present, this behavior can be turned off with property_overlay_scrolling().

## Constructor & Destructor Documentation

## ◆ ScrolledWindow() [1/3]

Gtk::ScrolledWindow::ScrolledWindow | ( | ScrolledWindow && | src | ) |
| noexcept

## ◆ ScrolledWindow() [2/3]

Gtk::ScrolledWindow::ScrolledWindow | ( | const ScrolledWindow & |  | ) |
| delete

## ◆ ~ScrolledWindow()

Gtk::ScrolledWindow::~ScrolledWindow | ( |  | ) |
| overridenoexcept

## ◆ ScrolledWindow() [3/3]

Gtk::ScrolledWindow::ScrolledWindow | ( |  | ) |

## Member Function Documentation

## ◆ get_child() [1/2]

Widget * Gtk::ScrolledWindow::get_child | ( |  | ) |

Gets the child widget of scrolled_window.

If the scrolled window automatically added a Gtk::Viewport, this function will return the viewport widget, and you can retrieve its child using Gtk::Viewport::get_child().

Returns
  The child widget of scrolled_window.

## ◆ get_child() [2/2]

const Widget * Gtk::ScrolledWindow::get_child | ( |  | ) | const

Gets the child widget of scrolled_window.

If the scrolled window automatically added a Gtk::Viewport, this function will return the viewport widget, and you can retrieve its child using Gtk::Viewport::get_child().

Returns
  The child widget of scrolled_window.

## ◆ get_hadjustment() [1/2]

Glib::RefPtr< Adjustment > Gtk::ScrolledWindow::get_hadjustment | ( |  | ) |

Returns the horizontal scrollbar’s adjustment.

This is the adjustment used to connect the horizontal scrollbar to the child widget’s horizontal scroll functionality.

Returns
  The horizontal Gtk::Adjustment.

## ◆ get_hadjustment() [2/2]

Glib::RefPtr< const Adjustment > Gtk::ScrolledWindow::get_hadjustment | ( |  | ) | const

Returns the horizontal scrollbar’s adjustment.

This is the adjustment used to connect the horizontal scrollbar to the child widget’s horizontal scroll functionality.

Returns
  The horizontal Gtk::Adjustment.

## ◆ get_has_frame()

bool Gtk::ScrolledWindow::get_has_frame | ( |  | ) | const

Gets whether the scrolled window draws a frame.

Returns
  true if the scrolled_window has a frame.

## ◆ get_hscrollbar() [1/2]

Scrollbar * Gtk::ScrolledWindow::get_hscrollbar | ( |  | ) |

Returns the horizontal scrollbar of scrolled_window.

Returns
  The horizontal scrollbar of the scrolled window.

## ◆ get_hscrollbar() [2/2]

const Scrollbar * Gtk::ScrolledWindow::get_hscrollbar | ( |  | ) | const

Returns the horizontal scrollbar of scrolled_window.

Returns
  The horizontal scrollbar of the scrolled window.

## ◆ get_kinetic_scrolling()

bool Gtk::ScrolledWindow::get_kinetic_scrolling | ( |  | ) | const

Returns the specified kinetic scrolling behavior.

Returns
  The scrolling behavior flags.

## ◆ get_max_content_height()

int Gtk::ScrolledWindow::get_max_content_height | ( |  | ) | const

Returns the maximum content height set.

Returns
  The maximum content height, or -1.

## ◆ get_max_content_width()

int Gtk::ScrolledWindow::get_max_content_width | ( |  | ) | const

Returns the maximum content width set.

Returns
  The maximum content width, or -1.

## ◆ get_min_content_height()

int Gtk::ScrolledWindow::get_min_content_height | ( |  | ) | const

Gets the minimal content height of scrolled_window.

Returns
  The minimal content height.

## ◆ get_min_content_width()

int Gtk::ScrolledWindow::get_min_content_width | ( |  | ) | const

Gets the minimum content width of scrolled_window.

Returns
  The minimum content width.

## ◆ get_overlay_scrolling()

bool Gtk::ScrolledWindow::get_overlay_scrolling | ( |  | ) | const

Returns whether overlay scrolling is enabled for this scrolled window.

Returns
  true if overlay scrolling is enabled.

## ◆ get_placement()

CornerType Gtk::ScrolledWindow::get_placement | ( |  | ) | const

Gets the placement of the contents with respect to the scrollbars.

Returns
  The current placement value.

## ◆ get_policy()

void Gtk::ScrolledWindow::get_policy | ( | PolicyType & | hscrollbar_policy,
|  | PolicyType & | vscrollbar_policy ) const

Retrieves the current policy values for the horizontal and vertical scrollbars.

See set_policy().

Parameters

  hscrollbar_policy | Location to store the policy for the horizontal scrollbar.
  vscrollbar_policy | Location to store the policy for the vertical scrollbar.

## ◆ get_propagate_natural_height()

bool Gtk::ScrolledWindow::get_propagate_natural_height | ( |  | ) | const

Reports whether the natural height of the child will be calculated and propagated through the scrolled window’s requested natural height.

Returns
  Whether natural height propagation is enabled.

## ◆ get_propagate_natural_width()

bool Gtk::ScrolledWindow::get_propagate_natural_width | ( |  | ) | const

Reports whether the natural width of the child will be calculated and propagated through the scrolled window’s requested natural width.

Returns
  Whether natural width propagation is enabled.

## ◆ get_type()

GType Gtk::ScrolledWindow::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ get_vadjustment() [1/2]

Glib::RefPtr< Adjustment > Gtk::ScrolledWindow::get_vadjustment | ( |  | ) |

Returns the vertical scrollbar’s adjustment.

This is the adjustment used to connect the vertical scrollbar to the child widget’s vertical scroll functionality.

Returns
  The vertical Gtk::Adjustment.

## ◆ get_vadjustment() [2/2]

Glib::RefPtr< const Adjustment > Gtk::ScrolledWindow::get_vadjustment | ( |  | ) | const

Returns the vertical scrollbar’s adjustment.

This is the adjustment used to connect the vertical scrollbar to the child widget’s vertical scroll functionality.

Returns
  The vertical Gtk::Adjustment.

## ◆ get_vscrollbar() [1/2]

Scrollbar * Gtk::ScrolledWindow::get_vscrollbar | ( |  | ) |

Returns the vertical scrollbar of scrolled_window.

Returns
  The vertical scrollbar of the scrolled window.

## ◆ get_vscrollbar() [2/2]

const Scrollbar * Gtk::ScrolledWindow::get_vscrollbar | ( |  | ) | const

Returns the vertical scrollbar of scrolled_window.

Returns
  The vertical scrollbar of the scrolled window.

## ◆ gobj() [1/2]

GtkScrolledWindow * Gtk::ScrolledWindow::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkScrolledWindow * Gtk::ScrolledWindow::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ operator=() [1/2]

ScrolledWindow & Gtk::ScrolledWindow::operator= | ( | const ScrolledWindow & |  | ) |
| delete

## ◆ operator=() [2/2]

ScrolledWindow & Gtk::ScrolledWindow::operator= | ( | ScrolledWindow && | src | ) |
| noexcept

## ◆ property_child() [1/2]

Glib::PropertyProxy< Widget * > Gtk::ScrolledWindow::property_child | ( |  | ) |

The child widget.

When setting this property, if the child widget does not implement Gtk::Scrollable, the scrolled window will add the child to a Gtk::Viewport and then set the viewport as the child.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_child() [2/2]

Glib::PropertyProxy_ReadOnly< Widget * > Gtk::ScrolledWindow::property_child | ( |  | ) | const

The child widget.

When setting this property, if the child widget does not implement Gtk::Scrollable, the scrolled window will add the child to a Gtk::Viewport and then set the viewport as the child.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_hadjustment() [1/2]

Glib::PropertyProxy< Glib::RefPtr< Adjustment > > Gtk::ScrolledWindow::property_hadjustment | ( |  | ) |

The Gtk::Adjustment for the horizontal position.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_hadjustment() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Adjustment > > Gtk::ScrolledWindow::property_hadjustment | ( |  | ) | const

The Gtk::Adjustment for the horizontal position.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_has_frame() [1/2]

Glib::PropertyProxy< bool > Gtk::ScrolledWindow::property_has_frame | ( |  | ) |

Whether to draw a frame around the contents.

Default value: false

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_has_frame() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::ScrolledWindow::property_has_frame | ( |  | ) | const

Whether to draw a frame around the contents.

Default value: false

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_hscrollbar_policy() [1/2]

Glib::PropertyProxy< PolicyType > Gtk::ScrolledWindow::property_hscrollbar_policy | ( |  | ) |

When the horizontal scrollbar is displayed.

Use Gtk::ScrolledWindow::set_policy() to set this property.

Default value: Gtk::PolicyType::AUTOMATIC

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_hscrollbar_policy() [2/2]

Glib::PropertyProxy_ReadOnly< PolicyType > Gtk::ScrolledWindow::property_hscrollbar_policy | ( |  | ) | const

When the horizontal scrollbar is displayed.

Use Gtk::ScrolledWindow::set_policy() to set this property.

Default value: Gtk::PolicyType::AUTOMATIC

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_kinetic_scrolling() [1/2]

Glib::PropertyProxy< bool > Gtk::ScrolledWindow::property_kinetic_scrolling | ( |  | ) |

Whether kinetic scrolling is enabled or not.

Kinetic scrolling only applies to devices with source Gdk::InputSource::TOUCHSCREEN.

Default value: true

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_kinetic_scrolling() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::ScrolledWindow::property_kinetic_scrolling | ( |  | ) | const

Whether kinetic scrolling is enabled or not.

Kinetic scrolling only applies to devices with source Gdk::InputSource::TOUCHSCREEN.

Default value: true

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_max_content_height() [1/2]

Glib::PropertyProxy< int > Gtk::ScrolledWindow::property_max_content_height | ( |  | ) |

The maximum content height of scrolled_window.

Default value: -1

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_max_content_height() [2/2]

Glib::PropertyProxy_ReadOnly< int > Gtk::ScrolledWindow::property_max_content_height | ( |  | ) | const

The maximum content height of scrolled_window.

Default value: -1

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_max_content_width() [1/2]

Glib::PropertyProxy< int > Gtk::ScrolledWindow::property_max_content_width | ( |  | ) |

The maximum content width of scrolled_window.

Default value: -1

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_max_content_width() [2/2]

Glib::PropertyProxy_ReadOnly< int > Gtk::ScrolledWindow::property_max_content_width | ( |  | ) | const

The maximum content width of scrolled_window.

Default value: -1

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_min_content_height() [1/2]

Glib::PropertyProxy< int > Gtk::ScrolledWindow::property_min_content_height | ( |  | ) |

The minimum content height of scrolled_window.

Default value: -1

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_min_content_height() [2/2]

Glib::PropertyProxy_ReadOnly< int > Gtk::ScrolledWindow::property_min_content_height | ( |  | ) | const

The minimum content height of scrolled_window.

Default value: -1

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_min_content_width() [1/2]

Glib::PropertyProxy< int > Gtk::ScrolledWindow::property_min_content_width | ( |  | ) |

The minimum content width of scrolled_window.

Default value: -1

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_min_content_width() [2/2]

Glib::PropertyProxy_ReadOnly< int > Gtk::ScrolledWindow::property_min_content_width | ( |  | ) | const

The minimum content width of scrolled_window.

Default value: -1

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_overlay_scrolling() [1/2]

Glib::PropertyProxy< bool > Gtk::ScrolledWindow::property_overlay_scrolling | ( |  | ) |

Whether overlay scrolling is enabled or not.

If it is, the scrollbars are only added as traditional widgets when a mouse is present. Otherwise, they are overlaid on top of the content, as narrow indicators.

Note that overlay scrolling can also be globally disabled, with the Gtk::Settings::property_gtk_overlay_scrolling() setting.

Default value: true

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_overlay_scrolling() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::ScrolledWindow::property_overlay_scrolling | ( |  | ) | const

Whether overlay scrolling is enabled or not.

If it is, the scrollbars are only added as traditional widgets when a mouse is present. Otherwise, they are overlaid on top of the content, as narrow indicators.

Note that overlay scrolling can also be globally disabled, with the Gtk::Settings::property_gtk_overlay_scrolling() setting.

Default value: true

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_propagate_natural_height() [1/2]

Glib::PropertyProxy< bool > Gtk::ScrolledWindow::property_propagate_natural_height | ( |  | ) |

Whether the natural height of the child should be calculated and propagated through the scrolled window’s requested natural height.

This is useful in cases where an attempt should be made to allocate exactly enough space for the natural size of the child.

Default value: false

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_propagate_natural_height() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::ScrolledWindow::property_propagate_natural_height | ( |  | ) | const

Whether the natural height of the child should be calculated and propagated through the scrolled window’s requested natural height.

This is useful in cases where an attempt should be made to allocate exactly enough space for the natural size of the child.

Default value: false

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_propagate_natural_width() [1/2]

Glib::PropertyProxy< bool > Gtk::ScrolledWindow::property_propagate_natural_width | ( |  | ) |

Whether the natural width of the child should be calculated and propagated through the scrolled window’s requested natural width.

This is useful in cases where an attempt should be made to allocate exactly enough space for the natural size of the child.

Default value: false

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_propagate_natural_width() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::ScrolledWindow::property_propagate_natural_width | ( |  | ) | const

Whether the natural width of the child should be calculated and propagated through the scrolled window’s requested natural width.

This is useful in cases where an attempt should be made to allocate exactly enough space for the natural size of the child.

Default value: false

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_vadjustment() [1/2]

Glib::PropertyProxy< Glib::RefPtr< Adjustment > > Gtk::ScrolledWindow::property_vadjustment | ( |  | ) |

The Gtk::Adjustment for the vertical position.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_vadjustment() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Adjustment > > Gtk::ScrolledWindow::property_vadjustment | ( |  | ) | const

The Gtk::Adjustment for the vertical position.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_vscrollbar_policy() [1/2]

Glib::PropertyProxy< PolicyType > Gtk::ScrolledWindow::property_vscrollbar_policy | ( |  | ) |

When the vertical scrollbar is displayed.

Use Gtk::ScrolledWindow::set_policy() to set this property.

Default value: Gtk::PolicyType::AUTOMATIC

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_vscrollbar_policy() [2/2]

Glib::PropertyProxy_ReadOnly< PolicyType > Gtk::ScrolledWindow::property_vscrollbar_policy | ( |  | ) | const

When the vertical scrollbar is displayed.

Use Gtk::ScrolledWindow::set_policy() to set this property.

Default value: Gtk::PolicyType::AUTOMATIC

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_window_placement() [1/2]

Glib::PropertyProxy< CornerType > Gtk::ScrolledWindow::property_window_placement | ( |  | ) |

Where the contents are located with respect to the scrollbars.

Default value: Gtk::CornerType::TOP_LEFT

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_window_placement() [2/2]

Glib::PropertyProxy_ReadOnly< CornerType > Gtk::ScrolledWindow::property_window_placement | ( |  | ) | const

Where the contents are located with respect to the scrollbars.

Default value: Gtk::CornerType::TOP_LEFT

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ set_child()

void Gtk::ScrolledWindow::set_child | ( | Widget & | child | ) |

Sets the child widget of scrolled_window.

If child does not implement the Gtk::Scrollable interface, the scrolled window will add child to a Gtk::Viewport instance and then add the viewport as its child widget.

Parameters

  child | The child widget.

## ◆ set_hadjustment()

void Gtk::ScrolledWindow::set_hadjustment | ( | const Glib::RefPtr< Adjustment > & | hadjustment | ) |

Sets the Gtk::Adjustment for the horizontal scrollbar.

Parameters

  hadjustment | The Gtk::Adjustment to use, or nullptr to create a new one.

## ◆ set_has_frame()

void Gtk::ScrolledWindow::set_has_frame | ( | bool | has_frame = true | ) |

Changes the frame drawn around the contents of scrolled_window.

Parameters

  has_frame | Whether to draw a frame around scrolled window contents.

## ◆ set_kinetic_scrolling()

void Gtk::ScrolledWindow::set_kinetic_scrolling | ( | bool | kinetic_scrolling = true | ) |

Turns kinetic scrolling on or off.

Kinetic scrolling only applies to devices with source Gdk::InputSource::TOUCHSCREEN.

Parameters

  kinetic_scrolling | true to enable kinetic scrolling.

## ◆ set_max_content_height()

void Gtk::ScrolledWindow::set_max_content_height | ( | int | height | ) |

Sets the maximum height that scrolled_window should keep visible.

The scrolled_window will grow up to this height before it starts scrolling the content.

It is a programming error to set the maximum content height to a value smaller than property_min_content_height().

Parameters

  height | The maximum content height.

## ◆ set_max_content_width()

void Gtk::ScrolledWindow::set_max_content_width | ( | int | width | ) |

Sets the maximum width that scrolled_window should keep visible.

The scrolled_window will grow up to this width before it starts scrolling the content.

It is a programming error to set the maximum content width to a value smaller than property_min_content_width().

Parameters

  width | The maximum content width.

## ◆ set_min_content_height()

void Gtk::ScrolledWindow::set_min_content_height | ( | int | height | ) |

Sets the minimum height that scrolled_window should keep visible.

Note that this can and (usually will) be smaller than the minimum size of the content.

It is a programming error to set the minimum content height to a value greater than property_max_content_height().

Parameters

  height | The minimal content height.

## ◆ set_min_content_width()

void Gtk::ScrolledWindow::set_min_content_width | ( | int | width | ) |

Sets the minimum width that scrolled_window should keep visible.

Note that this can and (usually will) be smaller than the minimum size of the content.

It is a programming error to set the minimum content width to a value greater than property_max_content_width().

Parameters

  width | The minimal content width.

## ◆ set_overlay_scrolling()

void Gtk::ScrolledWindow::set_overlay_scrolling | ( | bool | overlay_scrolling = true | ) |

Enables or disables overlay scrolling for this scrolled window.

Parameters

  overlay_scrolling | Whether to enable overlay scrolling.

## ◆ set_placement()

void Gtk::ScrolledWindow::set_placement | ( | CornerType | window_placement | ) |

Sets the placement of the contents with respect to the scrollbars for the scrolled window.

The default is Gtk::CornerType::TOP_LEFT, meaning the child is in the top left, with the scrollbars underneath and to the right. Other values in Gtk::CornerType are Gtk::CornerType::TOP_RIGHT, Gtk::CornerType::BOTTOM_LEFT, and Gtk::CornerType::BOTTOM_RIGHT.

See also get_placement() and unset_placement().

Parameters

  window_placement | Position of the child window.

## ◆ set_policy()

void Gtk::ScrolledWindow::set_policy | ( | PolicyType | hscrollbar_policy,
|  | PolicyType | vscrollbar_policy )

Sets the scrollbar policy for the horizontal and vertical scrollbars.

The policy determines when the scrollbar should appear; it is a value from the Gtk::PolicyType enumeration. If Gtk::PolicyType::ALWAYS, the scrollbar is always present; if Gtk::PolicyType::NEVER, the scrollbar is never present; if Gtk::PolicyType::AUTOMATIC, the scrollbar is present only if needed (that is, if the slider part of the bar would be smaller than the trough — the display is larger than the page size).

Parameters

  hscrollbar_policy | Policy for horizontal bar.
  vscrollbar_policy | Policy for vertical bar.

## ◆ set_propagate_natural_height()

void Gtk::ScrolledWindow::set_propagate_natural_height | ( | bool | propagate = true | ) |

Sets whether the natural height of the child should be calculated and propagated through the scrolled window’s requested natural height.

Parameters

  propagate | Whether to propagate natural height.

## ◆ set_propagate_natural_width()

void Gtk::ScrolledWindow::set_propagate_natural_width | ( | bool | propagate = true | ) |

Sets whether the natural width of the child should be calculated and propagated through the scrolled window’s requested natural width.

Parameters

  propagate | Whether to propagate natural width.

## ◆ set_vadjustment()

void Gtk::ScrolledWindow::set_vadjustment | ( | const Glib::RefPtr< Adjustment > & | vadjustment | ) |

Sets the Gtk::Adjustment for the vertical scrollbar.

Parameters

  vadjustment | The Gtk::Adjustment to use, or nullptr to create a new one.

## ◆ signal_edge_overshot()

Glib::SignalProxy< void(Gtk::PositionType)> Gtk::ScrolledWindow::signal_edge_overshot | ( |  | ) |

Slot Prototype:
  void on_my_edge_overshot(Gtk::PositionType pos)

Flags: Run Last

Emitted whenever user initiated scrolling makes the scrolled window firmly surpass the limits defined by the adjustment in that orientation.

A similar behavior without edge resistance is provided by the signal_edge_reached() signal.

Note
  The pos argument is LTR/RTL aware, so callers should be aware too if intending to provide behavior on horizontal edges.

Parameters

  pos | Edge side that was hit.

## ◆ signal_edge_reached()

Glib::SignalProxy< void(Gtk::PositionType)> Gtk::ScrolledWindow::signal_edge_reached | ( |  | ) |

Slot Prototype:
  void on_my_edge_reached(Gtk::PositionType pos)

Flags: Run Last

Emitted whenever user-initiated scrolling makes the scrolled window exactly reach the lower or upper limits defined by the adjustment in that orientation.

A similar behavior with edge resistance is provided by the signal_edge_overshot() signal.

Note
  The pos argument is LTR/RTL aware, so callers should be aware too if intending to provide behavior on horizontal edges.

Parameters

  pos | Edge side that was reached.

## ◆ unset_child()

void Gtk::ScrolledWindow::unset_child | ( |  | ) |

## ◆ unset_placement()

void Gtk::ScrolledWindow::unset_placement | ( |  | ) |

Unsets the placement of the contents with respect to the scrollbars.

If no window placement is set for a scrolled window, it defaults to Gtk::CornerType::TOP_LEFT.

## Friends And Related Symbol Documentation

## ◆ wrap()

Gtk::ScrolledWindow * wrap | ( | GtkScrolledWindow * | object,
|  | bool | take_copy = false )
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.